<?php declare(strict_types=1);

namespace Picea;

class Builder
{
    protected string $templatePath = "";

    public function __construct(string $templatePath = "./Builder/ClassTemplate.php")
    {
        $this->templatePath = $templatePath;
    }

    public function build(Compiler\Context &$context, string $compiledSource) : array
    {
        $className = "PiceaTemplate_" . $this->generateClassUID($compiledSource);

        $replace = [
            '%NAMESPACE%' => $context->namespace,
            '%USE%' => $context->renderUses(),
            '%CLASSNAME%' => $className,
            '%EXTENDS%' => '',
            '%CONTENT%' => $compiledSource,
        ];

        $classContent = str_replace(array_keys($replace), array_values($replace), file_get_contents($this->templatePath));

        return [
            $context->namespace, $className, $classContent,
        ];
    }

    public function generateClassUID(string $filePath) : string
    {
        return md5($filePath);
    }
}
